#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_ACCESSIBLE_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_ACCESSIBLE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_accessible.eo.h"
}

#include <string>

struct elm_interface_atspi_accessible;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct elm_interface_atspi_accessible
{
#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   /// @param cb 
   /// @param data 
   ///
   static Elm_Atspi_Event_Handler * event_handler_add(Eo_Event_Cb cb_, void * data_);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   /// @param handler 
   ///
   static void event_handler_del(Elm_Atspi_Event_Handler * handler_);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   /// @param accessible 
   /// @param event 
   /// @param event_info 
   ///
   static void event_emit(::elm_interface_atspi_accessible accessible_, const Eo_Event_Description * event_, void * event_info_);
#endif

   /// @param type 
   /// @param relation_object 
   ///
   bool relationship_append(Elm_Atspi_Relation_Type type_, ::elm_interface_atspi_accessible relation_object_) const;

   /// @param type 
   /// @param relation_object 
   ///
   void relationship_remove(Elm_Atspi_Relation_Type type_, ::elm_interface_atspi_accessible relation_object_) const;

   void relationships_clear() const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::string_view localized_role_name_get() const;
#endif

   char * name_get() const;

   void name_set(char * name_) const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   Elm_Atspi_Relation_Set relation_set_get() const;
#endif

   Elm_Atspi_Role role_get() const;

   void role_set(Elm_Atspi_Role role_) const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::list< ::elm_interface_atspi_accessible > children_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::string_view role_name_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::list< Elm_Atspi_Attribute * > attributes_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   int index_in_parent_get() const;
#endif

   ::efl::eina::string_view description_get() const;

   void description_set(::efl::eina::string_view description_) const;

   ::elm_interface_atspi_accessible parent_get() const;

   void parent_set(::elm_interface_atspi_accessible parent_) const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   Elm_Atspi_State_Set state_set_get() const;
#endif

   ::efl::eina::string_view translation_domain_get() const;

   void translation_domain_set(::efl::eina::string_view domain_) const;

   Elm_Atspi_Type type_get() const;

   void type_set(Elm_Atspi_Type type_) const;

   ::efl::eo::concrete root_get() const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_children_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED );
   }

   template <typename T>
   void
   callback_children_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_visible_data_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED );
   }

   template <typename T>
   void
   callback_visible_data_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_active_descendant_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED );
   }

   template <typename T>
   void
   callback_active_descendant_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_added_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED );
   }

   template <typename T>
   void
   callback_added_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_removed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED );
   }

   template <typename T>
   void
   callback_removed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_ACCESSIBLE_MIXIN);
   }

   operator ::elm_interface_atspi_accessible() const;
   operator ::elm_interface_atspi_accessible&();
   operator ::elm_interface_atspi_accessible const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm_interface_atspi_accessible*() const { return static_cast<::elm_interface_atspi_accessible*>(static_cast<D const*>(this)->p); }
      operator ::elm_interface_atspi_accessible const*() const { return static_cast<::elm_interface_atspi_accessible const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm_interface_atspi_accessible const*() const { return static_cast<::elm_interface_atspi_accessible const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class elm_interface_atspi_accessible
struct elm_interface_atspi_accessible
      : ::efl::eo::concrete
{
   //@{
   /**
      @brief Constructs a new elm_interface_atspi_accessible object.

      Constructs a new elm_interface_atspi_accessible object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm_interface_atspi_accessible my_elm_interface_atspi_accessible(efl::eo::parent = parent_object);
      @endcode

      @see elm_interface_atspi_accessible(Eo* eo)
   */
   explicit elm_interface_atspi_accessible(::efl::eo::parent_type _p)
      : elm_interface_atspi_accessible(_ctors_call(_p))
   {}

   explicit elm_interface_atspi_accessible()
      : elm_interface_atspi_accessible(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_accessible(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_accessible(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_accessible(elm_interface_atspi_accessible const& other)
      : elm_interface_atspi_accessible(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_accessible() {}

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   /// @param cb 
   /// @param data 
   ///
   static Elm_Atspi_Event_Handler * event_handler_add(Eo_Event_Cb cb_, void * data_);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   /// @param handler 
   ///
   static void event_handler_del(Elm_Atspi_Event_Handler * handler_);
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   /// @param accessible 
   /// @param event 
   /// @param event_info 
   ///
   static void event_emit(::elm_interface_atspi_accessible accessible_, const Eo_Event_Description * event_, void * event_info_);
#endif

   /// @param type 
   /// @param relation_object 
   ///
   bool relationship_append(Elm_Atspi_Relation_Type type_, ::elm_interface_atspi_accessible relation_object_) const;

   /// @param type 
   /// @param relation_object 
   ///
   void relationship_remove(Elm_Atspi_Relation_Type type_, ::elm_interface_atspi_accessible relation_object_) const;

   void relationships_clear() const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::string_view localized_role_name_get() const;
#endif

   char * name_get() const;

   void name_set(char * name_) const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   Elm_Atspi_Relation_Set relation_set_get() const;
#endif

   Elm_Atspi_Role role_get() const;

   void role_set(Elm_Atspi_Role role_) const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::list< ::elm_interface_atspi_accessible > children_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::string_view role_name_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   ::efl::eina::list< Elm_Atspi_Attribute * > attributes_get() const;
#endif

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   int index_in_parent_get() const;
#endif

   ::efl::eina::string_view description_get() const;

   void description_set(::efl::eina::string_view description_) const;

   ::elm_interface_atspi_accessible parent_get() const;

   void parent_set(::elm_interface_atspi_accessible parent_) const;

#ifdef ELM_INTERFACE_ATSPI_ACCESSIBLE_PROTECTED
   Elm_Atspi_State_Set state_set_get() const;
#endif

   ::efl::eina::string_view translation_domain_get() const;

   void translation_domain_set(::efl::eina::string_view domain_) const;

   Elm_Atspi_Type type_get() const;

   void type_set(Elm_Atspi_Type type_) const;

   ::efl::eo::concrete root_get() const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_active_descendant_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED );
   }

   template <typename T>
   void
   callback_active_descendant_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANT_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_added_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED );
   }

   template <typename T>
   void
   callback_added_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ADDED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_children_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED );
   }

   template <typename T>
   void
   callback_children_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_removed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED );
   }

   template <typename T>
   void
   callback_removed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_REMOVED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_visible_data_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, priority_,
            &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED );
   }

   template <typename T>
   void
   callback_visible_data_changed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_ACCESSIBLE_MIXIN);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm_interface_atspi_accessible::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm_interface_atspi_accessible* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm_interface_atspi_accessible::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm_interface_atspi_accessible const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_INTERFACE_ATSPI_ACCESSIBLE_MIXIN, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm_interface_atspi_accessible) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm_interface_atspi_accessible>::value, "");


#include "elm_interface_atspi_accessible.eo.impl.hh"

#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_ACCESSIBLE_HH

