#ifndef EFL_GENERATED_ELM_SYS_NOTIFY_INTERFACE_HH
#define EFL_GENERATED_ELM_SYS_NOTIFY_INTERFACE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_sys_notify_interface.eo.h"
}

#include <string>

namespace elm {

struct sys_notify_interface;

}

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

namespace elm {

struct sys_notify_interface
{
   /// @param replaces_id 
   /// @param icon 
   /// @param summary 
   /// @param body 
   /// @param urgency 
   /// @param timeout 
   /// @param cb 
   /// @param cb_data 
   ///
   void send(unsigned int replaces_id_, ::efl::eina::string_view icon_, ::efl::eina::string_view summary_, ::efl::eina::optional< ::efl::eina::string_view > body_, Elm_Sys_Notify_Urgency urgency_, int timeout_, Elm_Sys_Notify_Send_Cb cb_, const void * cb_data_) const;

   /// @param icon 
   /// @param summary 
   /// @param body 
   ///
   void simple_send(::efl::eina::string_view icon_, ::efl::eina::string_view summary_, ::efl::eina::string_view body_) const;

   /// @param id 
   ///
   void close(unsigned int id_) const;



   static Eo_Class const* _eo_class()
   {
      return(ELM_SYS_NOTIFY_INTERFACE_INTERFACE);
   }

   operator ::elm::sys_notify_interface() const;
   operator ::elm::sys_notify_interface&();
   operator ::elm::sys_notify_interface const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm::sys_notify_interface*() const { return static_cast<::elm::sys_notify_interface*>(static_cast<D const*>(this)->p); }
      operator ::elm::sys_notify_interface const*() const { return static_cast<::elm::sys_notify_interface const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm::sys_notify_interface const*() const { return static_cast<::elm::sys_notify_interface const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}
/// @endcond

namespace elm {

/// @brief Class sys_notify_interface
struct sys_notify_interface
      : ::efl::eo::concrete
{
   //@{
   /**
      @brief Constructs a new elm::sys_notify_interface object.

      Constructs a new elm::sys_notify_interface object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm::sys_notify_interface my_sys_notify_interface(efl::eo::parent = parent_object);
      @endcode

      @see sys_notify_interface(Eo* eo)
   */
   explicit sys_notify_interface(::efl::eo::parent_type _p)
      : sys_notify_interface(_ctors_call(_p))
   {}

   explicit sys_notify_interface()
      : sys_notify_interface(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit sys_notify_interface(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit sys_notify_interface(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   sys_notify_interface(sys_notify_interface const& other)
      : sys_notify_interface(eo_ref(other._eo_ptr()))
   {}

   ~sys_notify_interface() {}

   /// @param replaces_id 
   /// @param icon 
   /// @param summary 
   /// @param body 
   /// @param urgency 
   /// @param timeout 
   /// @param cb 
   /// @param cb_data 
   ///
   void send(unsigned int replaces_id_, ::efl::eina::string_view icon_, ::efl::eina::string_view summary_, ::efl::eina::optional< ::efl::eina::string_view > body_, Elm_Sys_Notify_Urgency urgency_, int timeout_, Elm_Sys_Notify_Send_Cb cb_, const void * cb_data_) const;

   /// @param icon 
   /// @param summary 
   /// @param body 
   ///
   void simple_send(::efl::eina::string_view icon_, ::efl::eina::string_view summary_, ::efl::eina::string_view body_) const;

   /// @param id 
   ///
   void close(unsigned int id_) const;



   static Eo_Class const* _eo_class()
   {
      return(ELM_SYS_NOTIFY_INTERFACE_INTERFACE);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm::sys_notify_interface::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm::sys_notify_interface* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm::sys_notify_interface::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm::sys_notify_interface const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_SYS_NOTIFY_INTERFACE_INTERFACE, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm::sys_notify_interface) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm::sys_notify_interface>::value, "");

}


#include "elm_sys_notify_interface.eo.impl.hh"

#endif // EFL_GENERATED_ELM_SYS_NOTIFY_INTERFACE_HH

